# Migrate from v3 to v4

*Last update: 2025-07-31*

## Migrate your application

Migrating from v3 to v4 requires updating your endpoint URLs to call v4 and
updating your application to account for breaking changes.

### Update your API calls from v3 to v4

To use v4 instead of v3, update your requests to use new v4 endpoints.

For example, to call the [`advertisers.get`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers/get) method with v3, use the
following URL:

    GET https://displayvideo.googleapis.com/v3/advertisers/advertiserId

For v4, update the URL to the following:

    GET https://displayvideo.googleapis.com/v4/advertisers/advertiserId

If you are using a client library to make requests to the API, use the most
recent version of the client library and update your configuration to use v4.

### Make required changes

We're introducing a number of breaking changes in v4. Review the following
instructions and make the required changes relevant to your existing use of the
Display \& Video 360 API.

#### Update calls regarding first- and third-party audience resources and related targeting

`FirstAndThirdPartyAudience` resources have been replaced by
`FirstPartyAndPartnerAudience` resources.

This change requires you to update the following:

- References to `FirstAndThirdPartyAudience` resources to use the new [`FirstPartyAndPartnerAudience`](https://developers.google.com/display-video/api/reference/rest/v4/firstPartyAndPartnerAudiences#FirstPartyAndPartnerAudience) resource.
- Existing requests to methods in the v3 service `firstAndThirdPartyAudiences` to the new v4 service [`firstPartyAndPartnerAudiences`](https://developers.google.com/display-video/api/reference/rest/v4/firstPartyAndPartnerAudiences#methods).
- Expectations of the default page size for [`firstPartyAndPartnerAudiences.list`](https://developers.google.com/display-video/api/reference/rest/v4/firstPartyAndPartnerAudiences/list) requests from 100 to 5000 items.
- References to the v3 `firstAndThirdPartyAudienceType` field to the new v4 [`firstPartyAndPartnerAudienceType`](https://developers.google.com/display-video/api/reference/rest/v4/firstPartyAndPartnerAudiences#FirstPartyAndPartnerAudience.FIELDS.first_party_and_partner_audience_type) field, using the new [`FirstPartyAndPartnerAudienceType`](https://developers.google.com/display-video/api/reference/rest/v4/firstPartyAndPartnerAudiences#FirstPartyAndPartnerAudienceType) enum type, with old values corresponding to the following new values:
  - `FIRST_AND_THIRD_PARTY_AUDIENCE_TYPE_FIRST_PARTY` to `TYPE_FIRST_PARTY`
  - `FIRST_AND_THIRD_PARTY_AUDIENCE_TYPE_THIRD_PARTY` to `TYPE_PARTNER`
- References to [`AudienceType`](https://developers.google.com/display-video/api/reference/rest/v4/firstPartyAndPartnerAudiences#AudienceType) enum value `LICENSED` to instead use
  one of the following new, more specific values:

  - `THIRD_PARTY`
  - `COMMERCE`
  - `LINEAR`
- References to [`AssignedTargetingOption`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.adGroups.targetingTypes.assignedTargetingOptions#AssignedTargetingOption) resources of
  [`TargetingType`](https://developers.google.com/display-video/api/reference/rest/v4/TargetingType) `TARGETING_TYPE_AUDIENCE_GROUP` to replace
  the v3 fields in
  [`AudienceGroupAssignedTargetingOptionDetails`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.adGroups.targetingTypes.assignedTargetingOptions#AssignedTargetingOption.AudienceGroupAssignedTargetingOptionDetails) with
  the following new v4 fields:

  - `excludedFirstAndThirdPartyAudienceGroup` with [`excludedFirstPartyAndPartnerAudienceGroup`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.adGroups.targetingTypes.assignedTargetingOptions#AssignedTargetingOption.AudienceGroupAssignedTargetingOptionDetails.FIELDS.excluded_first_party_and_partner_audience_group)
  - `includedFirstAndThirdPartyAudienceGroups` with [`includedFirstPartyAndPartnerAudienceGroups`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.adGroups.targetingTypes.assignedTargetingOptions#AssignedTargetingOption.AudienceGroupAssignedTargetingOptionDetails.FIELDS.included_first_party_and_partner_audience_groups)

#### Update existing ad group bulk list targeting requests

`advertisers.adGroups.bulkListAdGroupAssignedTargetingOptions` has been renamed
[`advertisers.adGroups.bulkListAssignedTargetingOptions`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.adGroups/bulkListAssignedTargetingOptions).
Update your existing requests to use the new method name.

#### Include an optimization objective when creating insertion orders

[`optimizationObjective`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.insertionOrders#InsertionOrder.FIELDS.optimization_objective) is now a required field in the
[`InsertionOrder`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.insertionOrders#InsertionOrder) resource. Update your
[`advertisers.insertionOrders.create`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.insertionOrders/create) requests to verify that this
field is set.

#### Remove references to the creative resource field `publisherReviewStatuses`

The `publisherReviewStatuses` field has been removed from the
[`ReviewStatusInfo`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.creatives#ReviewStatusInfo) object under the
[`Creative`](https://developers.google.com/display-video/api/reference/rest/v4/advertisers.creatives#Creative) resource after being [deprecated in June
2024](https://developers.google.com/display-video/api/deprecations#features.creative_publisher_review_statuses).